using System;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;

using Gizmox.WebGUI.Forms;
using Gizmox.WebGUI.Common.Resources;

namespace WebGUIExplorer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : Form
	{
		private Gizmox.WebGUI.Forms.TreeView treeView1;
		private Gizmox.WebGUI.Forms.Splitter splitter1;
		private Gizmox.WebGUI.Forms.ListView listView1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			// This call is required by the WebGUI Form Designer.
			InitializeComponent();

			listView1.Columns.Add(new ColumnHeader("Name","Name"));
			listView1.Columns.Add(new ColumnHeader("Extension","Extension"));
			listView1.UseInternalPaging = true;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Form Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.treeView1 = new Gizmox.WebGUI.Forms.TreeView();
			this.splitter1 = new Gizmox.WebGUI.Forms.Splitter();
			this.listView1 = new Gizmox.WebGUI.Forms.ListView();
			this.SuspendLayout();
			// 
			// treeView1
			// 
			this.treeView1.Anchor = Gizmox.WebGUI.Forms.AnchorStyles.None;
			this.treeView1.ClientSize = new System.Drawing.Size(168, 400);
			this.treeView1.Dock = Gizmox.WebGUI.Forms.DockStyle.Left;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.Size = new System.Drawing.Size(168, 400);
			this.treeView1.AfterSelect += new Gizmox.WebGUI.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
			this.treeView1.BeforeExpand += new Gizmox.WebGUI.Forms.TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
			// 
			// splitter1
			// 
			this.splitter1.Anchor = Gizmox.WebGUI.Forms.AnchorStyles.None;
			this.splitter1.ClientSize = new System.Drawing.Size(3, 400);
			this.splitter1.Dock = Gizmox.WebGUI.Forms.DockStyle.Left;
			this.splitter1.Location = new System.Drawing.Point(168, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 400);
			// 
			// listView1
			// 
			this.listView1.Anchor = Gizmox.WebGUI.Forms.AnchorStyles.None;
			this.listView1.ClientSize = new System.Drawing.Size(229, 400);
			this.listView1.Dock = Gizmox.WebGUI.Forms.DockStyle.Fill;
			this.listView1.Location = new System.Drawing.Point(171, 0);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(229, 400);
			// 
			// Form1
			// 
			this.ClientSize = new System.Drawing.Size(400, 374);
			this.Controls.Add(this.listView1);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.treeView1);
			this.DockPadding.All = 0;
			this.DockPadding.Bottom = 0;
			this.DockPadding.Left = 0;
			this.DockPadding.Right = 0;
			this.DockPadding.Top = 0;
			this.Size = new System.Drawing.Size(400, 374);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void Form1_Load(object sender, System.EventArgs e)
		{
			LoadFolders(treeView1.Nodes,@"C:\inetpub\wwwroot");
		}

		private void treeView1_BeforeExpand(object sender, Gizmox.WebGUI.Forms.TreeViewCancelEventArgs e)
		{
			if(!e.Node.Loaded)
			{
				LoadFolders(e.Node.Nodes,e.Node.Tag as string);
				e.Node.Loaded = true;
			}
		}

		private void LoadFolders(TreeNodeCollection nodes,string path)
		{

			DirectoryInfo dir = new DirectoryInfo(path);

			bool hasFolders = dir.GetDirectories().Length>0;

			foreach(DirectoryInfo subdir in dir.GetDirectories())
			{
				TreeNode node = new TreeNode();

				node.Text = subdir.Name;
				node.Tag = subdir.FullName;
				node.IsExpanded = !hasFolders;
				node.Loaded = !hasFolders;
				node.HasNodes = hasFolders;
				node.Image = new IconResourceHandle("folder.gif");

				nodes.Add(node);
			}
			
		}

		private void treeView1_AfterSelect(object sender, Gizmox.WebGUI.Forms.TreeViewEventArgs e)
		{
			DirectoryInfo dir = new DirectoryInfo(e.Node.Tag as string);

			listView1.Items.Clear();

			foreach(FileInfo file in dir.GetFiles())
			{
				ListViewItem item = listView1.Items.Add(file.Name);
				item.SubItems.Add(file.Extension);
				item.Image = new IconResourceHandle("file.gif");
			}

		}


	}
}
